%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}
%define debug_package %{nil}

Name:           ccsm
Version:        0.7.5
Release:        3%{?dist}
Summary:        Plugin and configuration tool - Compiz Fusion Project
Vendor:         compiz-fusion repo
Packager:       Leigh Scott <leigh123linux@googlemail.com>
Group:          User Interface/Desktops
License:        GPL
URL:            http://www.opencompositing.org

Source0:        http://releases.compiz-fusion.org/%{version}/%{name}-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

# libdrm is not available on these arches
ExcludeArch:    s390 s390x ppc64
BuildArch:      noarch
Obsoletes:      compizconfig-settings-manager <= %{version}
Provides:       compizconfig-settings-manager = %{version}
BuildRequires:  python-devel
BuildRequires:  perl(XML::Parser), intltool, gettext
Requires:       compizconfig-python = %{version} , libcompizconfig = %{version}
Requires:       pygtk2 >= 2.10

%description
The Compiz Project brings 3D desktop visual effects that improve
usability of the X Window System and provide increased productivity
though plugins and themes contributed by the community giving a
rich desktop experience.

This package contains a gui configuration tool to configure Compiz
plugins and the composite window manager.

%prep
%setup -q 

%build
#configure 
#make %{?_smp_mflags}


%install
#rm -rf $RPM_BUILD_ROOT
#make install DESTDIR=$RPM_BUILD_ROOT
python setup.py install --prefix=%{_prefix} --root=$RPM_BUILD_ROOT

%find_lang %{name}

%post
update-desktop-database -q %{_datadir}/applications
if [ -x /usr/bin/gtk-update-icon-cache ]; then
        /usr/bin/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor
        /usr/bin/gtk-update-icon-cache -f -t   %{_datadir}/ccsm/icons/hicolor
fi

%postun
update-desktop-database -q %{_datadir}/applications
if [ -x /usr/bin/gtk-update-icon-cache ]; then
        /usr/bin/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor
        /usr/bin/gtk-update-icon-cache -f -t   %{_datadir}/ccsm/icons/hicolor
fi

%clean
rm -rf $RPM_BUILD_ROOT


%files -f %{name}.lang
%defattr(-,root,root,-)
%doc ChangeLog AUTHORS COPYING INSTALL NEWS README TODO VERSION
%{_bindir}/ccsm
%{_datadir}/applications/ccsm.desktop
%{_datadir}/ccsm/icons/hicolor/scalable/apps/*.svg
%{_datadir}/ccsm/icons/hicolor/scalable/categories/*.svg
%{_datadir}/ccsm/images/*.png
%{_datadir}/ccsm/icons/hicolor/22x22/*/*.png
%{_datadir}/ccsm/icons/hicolor/22x22/categories/dummy
%{_datadir}/icons/hicolor/22x22/apps/ccsm.png
%{_datadir}/icons/hicolor/22x22/apps/ccsm.svg
%{_datadir}/icons/hicolor/32x32/apps/ccsm.png
%{_datadir}/icons/hicolor/32x32/apps/ccsm.svg
%{_datadir}/icons/hicolor/scalable/apps/ccsm.svg
%{_datadir}/icons/hicolor/24x24/apps/ccsm.png
%{_datadir}/icons/hicolor/16x16/apps/ccsm.png
%{_datadir}/icons/hicolor/48x48/apps/ccsm.png
%{python_sitelib}/ccm/Widgets.py
%{python_sitelib}/ccm/Widgets.pyc
%{python_sitelib}/ccm/Widgets.pyo
%{python_sitelib}/ccm/Conflicts.py*
%{python_sitelib}/ccm/Constants.py*
%{python_sitelib}/ccm/Pages.py*
%{python_sitelib}/ccm/Settings.py*
%{python_sitelib}/ccm/Utils.py*
%{python_sitelib}/ccm/Window.py*
%{python_sitelib}/ccm/__init__.py*



%changelog
* Thu Apr 03 2008 Leigh Scott <leigh123linux@googlemail.com>
- 0.7.5 release

* Fri Mar 07 2008 Leigh Scott <leigh123linux@googlemail.com>
- 0.7.3 release

* Tue Aug 14 2007 Mohd Izhar Firdaus Ismail <mohd.izhar.firdaus@gmail.com> 0.5.2-0.1
- 0.5.2 release

* Sun Jul 03 2007 Mohd Izhar Firdaus Ismail <mohd.izhar.firdaus@gmail.com> 0.0.1-0.4444070703git
- 20070703git

* Sun Jun 30 2007 Mohd Izhar Firdaus Ismail <mohd.izhar.firdaus@gmail.com> 0.0.1-0.3.20070630git
- 20070630git
- Added BuildReq gettext
- Added Require compizconfig-python

* Sun Jun 27 2007 Mohd Izhar Firdaus Ismail <mohd.izhar.firdaus@gmail.com> 0.0.1-0.1.20070625git
- 20070625git

* Sun Jun 25 2007 Mohd Izhar Firdaus Ismail <mohd.izhar.firdaus@gmail.com> 0.0.1-0.1.20070625git
- fixed release numbering to follow Fedora guidelines
- added require pygtk2

* Sun Jun 24 2007 Mohd Izhar Firdaus Ismail <mohd.izhar.firdaus@gmail.com> 0.0.1-20070622git
- Initial specfile, borrowing descriptions from Trevino ubuntu debs
