/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _CUBEADDON_OPTIONS_H
#define _CUBEADDON_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    CubeaddonDisplayOptionNum
} CubeaddonDisplayOptions;

typedef void (*cubeaddonDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, CubeaddonDisplayOptions num);

CompOption *cubeaddonGetDisplayOption (CompDisplay *d, CubeaddonDisplayOptions num);

typedef enum
{
    CubeaddonScreenOptionReflection,
    CubeaddonScreenOptionGroundColor1,
    CubeaddonScreenOptionGroundColor2,
    CubeaddonScreenOptionGroundSize,
    CubeaddonScreenOptionIntensity,
    CubeaddonScreenOptionAutoZoom,
    CubeaddonScreenOptionZoomManualOnly,
    CubeaddonScreenOptionMode,
    CubeaddonScreenOptionCylinder,
    CubeaddonScreenOptionCylinderManualOnly,
    CubeaddonScreenOptionFillCaps,
    CubeaddonScreenOptionTopColor,
    CubeaddonScreenOptionBottomColor,
    CubeaddonScreenOptionNum
} CubeaddonScreenOptions;

typedef void (*cubeaddonScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, CubeaddonScreenOptions num);

CompOption *cubeaddonGetScreenOption (CompScreen *s, CubeaddonScreenOptions num);

typedef enum
{
    ModeJumpy = 0,
    ModeJumpyReflection = 1,
    ModeDistance = 2,
    ModeAbove = 3,
} CubeaddonModeEnum;

Bool             cubeaddonGetReflection (CompScreen *s);
CompOption *     cubeaddonGetReflectionOption (CompScreen *s);
void             cubeaddonSetReflectionNotify (CompScreen *s, cubeaddonScreenOptionChangeNotifyProc notify);

unsigned short * cubeaddonGetGroundColor1 (CompScreen *s);
unsigned short   cubeaddonGetGroundColor1Red (CompScreen *s);
unsigned short   cubeaddonGetGroundColor1Green (CompScreen *s);
unsigned short   cubeaddonGetGroundColor1Blue (CompScreen *s);
unsigned short   cubeaddonGetGroundColor1Alpha (CompScreen *s);
CompOption *     cubeaddonGetGroundColor1Option (CompScreen *s);
void             cubeaddonSetGroundColor1Notify (CompScreen *s, cubeaddonScreenOptionChangeNotifyProc notify);

unsigned short * cubeaddonGetGroundColor2 (CompScreen *s);
unsigned short   cubeaddonGetGroundColor2Red (CompScreen *s);
unsigned short   cubeaddonGetGroundColor2Green (CompScreen *s);
unsigned short   cubeaddonGetGroundColor2Blue (CompScreen *s);
unsigned short   cubeaddonGetGroundColor2Alpha (CompScreen *s);
CompOption *     cubeaddonGetGroundColor2Option (CompScreen *s);
void             cubeaddonSetGroundColor2Notify (CompScreen *s, cubeaddonScreenOptionChangeNotifyProc notify);

float            cubeaddonGetGroundSize (CompScreen *s);
CompOption *     cubeaddonGetGroundSizeOption (CompScreen *s);
void             cubeaddonSetGroundSizeNotify (CompScreen *s, cubeaddonScreenOptionChangeNotifyProc notify);

float            cubeaddonGetIntensity (CompScreen *s);
CompOption *     cubeaddonGetIntensityOption (CompScreen *s);
void             cubeaddonSetIntensityNotify (CompScreen *s, cubeaddonScreenOptionChangeNotifyProc notify);

Bool             cubeaddonGetAutoZoom (CompScreen *s);
CompOption *     cubeaddonGetAutoZoomOption (CompScreen *s);
void             cubeaddonSetAutoZoomNotify (CompScreen *s, cubeaddonScreenOptionChangeNotifyProc notify);

Bool             cubeaddonGetZoomManualOnly (CompScreen *s);
CompOption *     cubeaddonGetZoomManualOnlyOption (CompScreen *s);
void             cubeaddonSetZoomManualOnlyNotify (CompScreen *s, cubeaddonScreenOptionChangeNotifyProc notify);

int              cubeaddonGetMode (CompScreen *s);
CompOption *     cubeaddonGetModeOption (CompScreen *s);
void             cubeaddonSetModeNotify (CompScreen *s, cubeaddonScreenOptionChangeNotifyProc notify);

Bool             cubeaddonGetCylinder (CompScreen *s);
CompOption *     cubeaddonGetCylinderOption (CompScreen *s);
void             cubeaddonSetCylinderNotify (CompScreen *s, cubeaddonScreenOptionChangeNotifyProc notify);

Bool             cubeaddonGetCylinderManualOnly (CompScreen *s);
CompOption *     cubeaddonGetCylinderManualOnlyOption (CompScreen *s);
void             cubeaddonSetCylinderManualOnlyNotify (CompScreen *s, cubeaddonScreenOptionChangeNotifyProc notify);

Bool             cubeaddonGetFillCaps (CompScreen *s);
CompOption *     cubeaddonGetFillCapsOption (CompScreen *s);
void             cubeaddonSetFillCapsNotify (CompScreen *s, cubeaddonScreenOptionChangeNotifyProc notify);

unsigned short * cubeaddonGetTopColor (CompScreen *s);
unsigned short   cubeaddonGetTopColorRed (CompScreen *s);
unsigned short   cubeaddonGetTopColorGreen (CompScreen *s);
unsigned short   cubeaddonGetTopColorBlue (CompScreen *s);
unsigned short   cubeaddonGetTopColorAlpha (CompScreen *s);
CompOption *     cubeaddonGetTopColorOption (CompScreen *s);
void             cubeaddonSetTopColorNotify (CompScreen *s, cubeaddonScreenOptionChangeNotifyProc notify);

unsigned short * cubeaddonGetBottomColor (CompScreen *s);
unsigned short   cubeaddonGetBottomColorRed (CompScreen *s);
unsigned short   cubeaddonGetBottomColorGreen (CompScreen *s);
unsigned short   cubeaddonGetBottomColorBlue (CompScreen *s);
unsigned short   cubeaddonGetBottomColorAlpha (CompScreen *s);
CompOption *     cubeaddonGetBottomColorOption (CompScreen *s);
void             cubeaddonSetBottomColorNotify (CompScreen *s, cubeaddonScreenOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
